#include <QTRSensors.h>

#define sagtabanhiz 60
#define soltabanhiz 60
#define solmotoryon  10
#define solmotorpwmpin 9
#define sagmotoryon 5
#define sagmotorpwmpin 6

QTRSensors qtr;

const uint8_t SensorCount = 8;
uint16_t sensorValues[SensorCount];

void setup()
{

      // configure the sensors
      qtr.setTypeRC();
      qtr.setSensorPins((const uint8_t[]){2, A0, A1, 4, A2, A3, A4, A5}, SensorCount);
      qtr.setEmitterPin(2);

  
      delay(500);
      pinMode(sagmotoryon, OUTPUT);
      pinMode(sagmotorpwmpin, OUTPUT);
      pinMode(solmotoryon, OUTPUT);
      pinMode(solmotorpwmpin, OUTPUT);
 
      delay(500);
      pinMode(LED_BUILTIN, OUTPUT);
      digitalWrite(LED_BUILTIN, HIGH); // turn on Arduino's LED to indicate we are in calibration mode
       
     for (uint16_t i = 0; i < 400; i++)
     { 
         //if ( 0 <= i && i < 5   )  hafifsagadon();       
         //if ( 5 <= i && i  < 15   )  hafifsoladon(); 
         //if ( 15 <= i && i < 25   )  hafifsagadon();       
         //if ( 25 <= i && i < 35   )  hafifsoladon(); 
         //if ( 35 <= i && i < 45   )  hafifsagadon();       
         //if ( 45 <= i && i < 55  )  hafifsoladon(); 
         //if ( 55 <= i && i < 65   )  hafifsagadon();       
         //if ( 65 <= i && i < 75  )  hafifsoladon();
         //if ( 75 <= i && i < 85   )  hafifsagadon();       
         //if ( 85 <= i && i < 90  )  hafifsoladon();
  
         //if ( i >= 90  )  {frenle(); delay(5);}
        
       qtr.calibrate(); 
       delay(4);
      } 
    digitalWrite(LED_BUILTIN, LOW); // turn off Arduino's LED to indicate we are through with calibration
    Serial.begin(9600);
    delay(2000);
} 

int sonhata = 0;
float Kp = 0.04;
float Kd = 0.8;

int sagmotorpwm = 0;
int solmotorpwm = 0;
int zemin=0;

void loop()
{ 

  // Pozisyon hesabı QTRlibrary tarafından yaptırılıyor
  uint16_t sensorValues[8]; 
  uint16_t position = qtr.readLineBlack(sensorValues);
 // unsigned int position = qtrrc.readLine(sensorValues,1,zemin); 
  int hata = position-3500;

  // zemin değiştirme kodları
 // if ( sensorValues[0]<200 && sensorValues[7]<200  ) { zemin=0;  }//beyaz
 // if ( sensorValues[0]>750 && sensorValues[7]>750  ) { zemin=1;  }//siyah
 

 
  //////////// motorlara verilecek hız düzeltme oran hesabı
  int duzeltmehizi = Kp * hata + Kd*(hata - sonhata);
  sonhata = hata;
    
   
  //////////// Motorlara uygulanacak kesin hız ayarları
   sagmotorpwm = sagtabanhiz + duzeltmehizi  ;
   solmotorpwm = soltabanhiz - duzeltmehizi  ;
  
   sagmotorpwm = constrain(sagmotorpwm, -255, 255); ///// Burada motorlara uygulanacak PWM değerlerine sınırlandırma getirilmiştir.
   solmotorpwm = constrain(solmotorpwm, -255, 255); 
   motorkontrol(sagmotorpwm,solmotorpwm);
  //   Seri monitörde hata, sağ ve sol motor hız değerlerini gösternek için alttaki satırı aktif yapınız
    // Serial.print(hata);  Serial.print(" "); Serial.print(sagmotorpwm); Serial.print(" "); Serial.println(solmotorpwm); delay(100);  

}
// Motor kontrol alt programı
void motorkontrol(int sagmotorpwm, int solmotorpwm){

  if(sagmotorpwm<=0) {
      sagmotorpwm=abs(sagmotorpwm);
      analogWrite(sagmotoryon, LOW);
      analogWrite(sagmotorpwmpin, sagmotorpwm);
    }
  else {
      analogWrite(sagmotoryon, sagmotorpwm);
      analogWrite(sagmotorpwmpin, LOW);
  }
  
  if(solmotorpwm<=0) {
     solmotorpwm=abs(solmotorpwm);
     analogWrite(solmotoryon, LOW);
     analogWrite(solmotorpwmpin, solmotorpwm);
    }
   else {
    analogWrite(solmotoryon, solmotorpwm);
    analogWrite(solmotorpwmpin, LOW);
   }
}


void frenle(){motorkontrol(0,0);}

void hafifsagadon(){motorkontrol(0,0);}

void hafifsoladon(){motorkontrol(0,0);}
